<template>
    <div class="col-xs-12">
        <h1 v-if="imports">Edit warehouse</h1>
        <h1 v-else>Add warehouse</h1>

        <div class="clearfix">
            <ul class="nav nav-tabs">
                <li class="active" v-bind:class="{active:details}">
                    <a href="#" @click="activateTab('details', $event)">Warehouse details</a>
                </li>
                <li v-bind:class="{active:stock}">
                    <a href="#" @click="activateTab('stock', $event)">Warehouse stock</a>
                </li>
            </ul>
        </div>

        <div class="details" v-if="details">
            <h2>Details</h2>
            <div class="col-xs-12 form-horizontal">
                <div class="form-group">
                    <label>Warehouse name</label>
                    <input type="text" v-model="warehouse.name" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Email:</label>
                    <input type="tel" v-model="warehouse.email" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Phone</label>
                    <input type="tel" v-model="warehouse.phone" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Fax</label>
                    <input type="tel" v-model="warehouse.fax" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>VAT number</label>
                    <input type="text" v-model="warehouse.vat_number" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Prefix or Suffix</label>
                    <select v-model="warehouse.prefix_suffix">
                        <option value="">No prefix/suffix</option>
                        <option value="prefix">Prefix</option>
                        <!--<option value="suffix">Suffix</option>-->
                    </select>
                </div>
                <div class="form-group" v-if="warehouse.prefix_suffix">
                    <label>SKU prefix/suffix text</label>
                    <input type="text" v-model="warehouse.prefix_suffix_text" class="form-control"/>
                </div>

                <h3>Address</h3>
                <div class="form-group">
                    <label>Street:</label>
                    <input type="text" v-model="warehouse.address.street" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>City:</label>
                    <input type="text" v-model="warehouse.address.city" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>State:</label>
                    <input type="text" v-model="warehouse.address.state" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Country:</label>
                    <select v-model="warehouse.address.country">
                        <option v-for="country in countries" v-bind:value="country.code">{{country.name}}</option>
                    </select>
                </div>
                <div class="form-group">
                    <label>Post code:</label>
                    <input type="text" v-model="warehouse.address.post_code" class="form-control"/>
                </div>

                <div class="form-group">
                    <label>Status</label>
                    <input type="checkbox" v-model="warehouse.status" :checked="false" class="form-control"/>
                </div>
                <div class="form-group">
                    <label>Primary</label>
                    <input type="checkbox" v-model="warehouse.primary" :checked="false" class="form-control"/>
                </div>

                <div class="col-sm-12">
                    <span class="btn btn-default custom-attrs-form__save" @click="saveWarehouse()">Save</span>
                    <span class="btn btn-danger repeater__button--delete" @click="deleteWarehouse()">Delete</span>
                </div>
            </div>
        </div>

        <div class="stock" v-if="stock">
            <h2>Stock</h2>
            <table></table>
        </div>
    </div>
</template>
<style>
</style>
<script>
    import $ from 'jquery';
    import 'jquery-ui';
    import 'jquery-ui/themes/base/base.css';
    import 'jquery-ui/themes/base/theme.css';
    import 'jquery-ui/themes/base/datepicker.css';
    import 'jquery-ui/ui/widgets/datepicker';
    import dt from 'datatables.net';
    import 'datatables.net-dt/css/jquery.dataTables.css'
    import 'yadcf';
    import moment from 'moment';

    dt(window, $);

    export default{
        data: function () {
            return {
                details: true,
                stock: false,
                settings: false,
                columns: [],
                options: {},
                yadcf_columns: [],
                countries: [],
                warehouse: {
                    address: {}
                }
            }
        },
        route: {
            data: function (transition) {
                var id = this.$route.params.id;
                if (id != undefined) {
                    return this.$http.get('/api/v1/warehouses/warehouse/' + id).then(function (res) {
//						console.log(res);
                        this.warehouse = res.data;
                        console.log(this.warehouse);
                        return {
                            warehouse: res.data
                        }
                    });
                }
            }
        },
        ready: function () {
            this.getCountries().then(function (res) {
                this.countries = res;
            });
        },
        methods: {
            activateTab: function (tab, event) {
                event.preventDefault();
                if (tab == 'details') {
                    this.stock = false;
                    this.settings = false;
                    this.details = true;
                } else if (tab == 'settings') {
                    this.stock = false;
                    this.details = false;
                    this.settings = true;
                } else {
                    this.details = false;
                    this.settings = false;
                    this.stock = true;
                    this.getColumns().then(function (res) {
                        var self = this;
                        res.forEach(function (column, index) {
                            var element = {};
                            if (column.system) {
                                element = {
                                    data: column.code,
                                    title: column.name
                                }
                                if (column.code === 'name') {
                                    element.render = function (data, type, row) {
                                        return '<a href="#!/product/' + row._id + '">' + data + '</a>';
                                    }
                                }
                                if (column.type === 'date') {
                                    element.render = function (data, type, row) {
                                        return moment(data).format('YYYY-MM-DD hh:mm:ss');
                                    }
                                }
                            } else {
                                element = {
                                    "data": "attributes." + column.code,
                                    "title": column.name
                                }
                            }

                            var yadcf_element = {
                                column_number: index,
                                filter_type: column.type
                            }
                            if (column.type === 'date') {
                                var datetimepickerOptions = {
                                    timeFormat: 'HH:MM:SS',
                                    dateFormat: 'yy-mm-dd',
                                    timeInput: true
                                };
                                yadcf_element.datepicker_type = 'jquery-ui';
                                yadcf_element.date_format = 'yyyy-mm-dd HH:MM:SS';
                                yadcf_element.moment_date_format = 'YYYY-MM-DD hh:mm:ss';
                                yadcf_element.filter_plugin_options = datetimepickerOptions;
                            }
                            self.columns.push(element);
                            self.yadcf_columns.push(yadcf_element);
                        });
                        this.buildDt();
                    });
                }
            },
            deleteWarehouse: function () {
                if (this.warehouse.id) {
                    this.$http.delete('/api/v1/warehouses/delete/' + this.warehouse.id).then(function (res) {
                        console.log(res.data);
                    });
                }
            },
            saveWarehouse: function () {
                console.log(this.warehouse.prefix_suffix);
                if (!this.warehouse.prefix_suffix) {
                    delete(this.warehouse.prefix_suffix_text);
                }
                if (this.warehouse.id) {
                    this.$http.put('/api/v1/warehouses/update/' + this.warehouse.id, this.warehouse).then(function (res) {
                        console.log(res.data);
                    })
                } else {
                    this.$http.post('/api/v1/warehouses/create', this.warehouse).then(function (res) {
                        console.log(res.data);
                    })
                }
            },
            getCountries: function () {
                return this.$http.get('/api/v1/settings/countries').then(function (res) {
                    return res.data.data
                })
            },
            getColumns: function () {
                return this.$http.get('/api/v1/product-attributes/get-columns').then(function (res) {
                    return res.data;
                })
            },
            buildDt: function () {
                console.log('ok');
                console.log(this);
                self = this;
                this.options = {
                    processing: true,
                    serverSide: true,
                    lengthMenu: [[25, 50, 100, 200], [25, 50, 100, 200]],
                    ajax: {
                        url: '/api/v1/products',
                        data: function (d) {
                            d.columnsCount = self.columns.length,
                            d.type = 'warehouse',
                            d.id = self.$route.params.id
                        }
                    },
                    columns: self.columns
                }
                var datatable = $('table').DataTable(this.options);

                yadcf.init(datatable, this.yadcf_columns);
            },
        },
        components: {}
    }


</script>
